// Generated by CoffeeScript 1.3.3
(function() {
  var leakDetector, should, wd;

  should = require('should');

  leakDetector = (require('../common/leak-detector'))();

  wd = require('../../lib/main');

  exports.wd = {
    'browser init test': {
      "default": function(test) {
        var browser;
        browser = wd.remote();
        browser.defaultCapabilities.should.eql({
          browserName: 'firefox',
          version: '',
          javascriptEnabled: true,
          platform: 'ANY'
        });
        return browser.init(function(err) {
          should.not.exist(err);
          return browser.sessionCapabilities(function(err, capabilities) {
            should.not.exist(err);
            capabilities.browserName.should.equal('firefox');
            return browser.quit(function(err) {
              should.not.exist(err);
              return test.done();
            });
          });
        });
      },
      'using browser.defaultCapabilities': function(test) {
        var browser;
        browser = wd.remote();
        browser.defaultCapabilities.browserName = 'chrome';
        browser.defaultCapabilities.javascriptEnabled = false;
        browser.defaultCapabilities.should.eql({
          browserName: 'chrome',
          version: '',
          javascriptEnabled: false,
          platform: 'ANY'
        });
        return browser.init(function(err) {
          should.not.exist(err);
          return browser.sessionCapabilities(function(err, capabilities) {
            should.not.exist(err);
            capabilities.browserName.should.equal('chrome');
            return browser.quit(function(err) {
              should.not.exist(err);
              return test.done();
            });
          });
        });
      },
      'desired only': function(test) {
        var browser;
        browser = wd.remote();
        browser.defaultCapabilities.should.eql({
          browserName: 'firefox',
          version: '',
          javascriptEnabled: true,
          platform: 'ANY'
        });
        return browser.init({
          browserName: 'chrome'
        }, function(err) {
          should.not.exist(err);
          return browser.sessionCapabilities(function(err, capabilities) {
            should.not.exist(err);
            capabilities.browserName.should.equal('chrome');
            return browser.quit(function(err) {
              should.not.exist(err);
              return test.done();
            });
          });
        });
      },
      'desired overiding defaultCapabilities': function(test) {
        var browser;
        browser = wd.remote();
        browser.defaultCapabilities.browserName = 'chrome';
        browser.defaultCapabilities.should.eql({
          browserName: 'chrome',
          version: '',
          javascriptEnabled: true,
          platform: 'ANY'
        });
        return browser.init({
          browserName: 'firefox'
        }, function(err) {
          should.not.exist(err);
          return browser.sessionCapabilities(function(err, capabilities) {
            should.not.exist(err);
            capabilities.browserName.should.equal('firefox');
            return browser.quit(function(err) {
              should.not.exist(err);
              return test.done();
            });
          });
        });
      },
      'checking leaks': leakDetector.lookForLeaks
    }
  };

}).call(this);
